package java.util;

class HashtableEnumerator implements Enumeration {
   boolean keys;
   int index;
   HashtableEntry[] table;
   HashtableEntry entry;

   HashtableEnumerator(HashtableEntry[] table, boolean keys) {
      this.table = table;
      this.keys = keys;
      this.index = table.length;
   }

   public boolean hasMoreElements() {
      if (this.entry != null) {
         return true;
      } else {
         while(this.index-- > 0) {
            if ((this.entry = this.table[this.index]) != null) {
               return true;
            }
         }

         return false;
      }
   }

   public Object nextElement() {
      if (this.entry == null) {
         while(this.index-- > 0 && (this.entry = this.table[this.index]) == null) {
         }
      }

      if (this.entry != null) {
         HashtableEntry e = this.entry;
         this.entry = e.next;
         return this.keys ? e.key : e.value;
      } else {
         throw new NoSuchElementException("HashtableEnumerator");
      }
   }
}
